#include "../m_pd.h"

static t_class *grad_class;

typedef struct _grad {
	t_object x_obj;
	t_float x_f, x_min, x_max;
} t_grad;

void grad_float(t_grad *x, t_float f) {
	double range=x->x_f, min=x->x_min, scale=x->x_max-min;
	outlet_float(x->x_obj.ob_outlet, f / (range / scale) + min);
}

void *grad_new(t_symbol *s, int argc, t_atom *argv) {
	t_grad *x = (t_grad *)pd_new(grad_class);
	t_float range=100, min=0, max=1;
	
	switch (argc) {
	  case 3:
		max = atom_getfloat(argv+2);
		min = atom_getfloat(argv+1);
	  case 1:
		range = atom_getfloat(argv);
	  break;
	  case 2:
		max = atom_getfloat(argv+1);
		min = atom_getfloat(argv);
	}
	x->x_f=range; x->x_min=min; x->x_max=max;
	
	floatinlet_new(&x->x_obj, &x->x_f);
	floatinlet_new(&x->x_obj, &x->x_min);
	floatinlet_new(&x->x_obj, &x->x_max);
	outlet_new(&x->x_obj, &s_float);
	return (x);
}

void gradient_setup(void) {
	grad_class = class_new(gensym("gradient"),
		(t_newmethod)grad_new, 0,
		sizeof(t_grad), 0,
		A_GIMME, 0);
	
	class_addcreator((t_newmethod)grad_new, gensym("grad"),
		A_GIMME, 0);
	class_addfloat(grad_class, grad_float);
}

void grad_setup(void) {
	gradient_setup();
}
